#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
//#property  indicator_width1  2

//  
extern double FastEMA=12;
   double f0;
extern double SlowEMA=26;
   double s0;
extern int SignalSMA=9;
extern int Gap=0; //     .
   double gp;

 int History=0; // 0-  

double   MACD[], 
         Signal[]; 
double fper,sper; //  

// 
void init() { 
   if(FastEMA>1) {f0=2/(1+FastEMA); fper=FastEMA;}
   else {f0=FastEMA; fper=(2-FastEMA)/FastEMA;}
   if(SlowEMA>1) {s0=2/(1+SlowEMA); sper=SlowEMA;}
   else {s0=FastEMA; sper=(2-SlowEMA)/SlowEMA;}
   
   gp=Gap*Point;
   
   IndicatorDigits(5);
   
   string _macd="MACD("+DoubleToStr(fper,2)+","+DoubleToStr(sper,2);
   SetIndexBuffer(0,MACD); 
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexLabel(0,_macd+")");
   SetIndexEmptyValue(0,0.0);

   string _sg=SignalSMA+")";
   SetIndexBuffer(1,Signal); 
   SetIndexStyle(1,DRAW_LINE,2);
   SetIndexLabel(1,"Signal("+_sg);
   SetIndexEmptyValue(1,0.0);

   IndicatorShortName(_macd+","+_sg);
  }

void start() {
   int limit=Bars-IndicatorCounted()-1; 
   if(limit>1) {
      limit=Bars-1;
      ArrayInitialize(MACD,0.0);
      ArrayInitialize(Signal,0.0);
     }
   if(History!=0 && limit>History) limit=History-1; // -   

   //  
   for(int i=limit; i>=0; i--) { 
      //  
      static double base;
      double gap=Close[i+1]-Open[i];
      if(MathAbs(gap)>gp) base+=gap;
      if(i==limit && i>1) base=0; //  
      if(Gap==0) base=0;
      double c=Close[i]+base;
      /////////////////////////
      // MACD
      static double fm1,sm1;
      // fast MA
      if(i==limit && i>1) double fm0=c; //  
      else fm0=f0*c+(1-f0)*fm1; //  
      // slow MA
      if(i==limit && i>1) double sm0=c; //  
      else sm0=s0*c+(1-s0)*sm1; //  
      // 
      if(i>0) {fm1=fm0; sm1=sm0;}
      //
      MACD[i]=fm0-sm0; // MACD
     }
   // Signal
   for(i=0; i<limit; i++) Signal[i]=iMAOnArray(MACD,Bars,SignalSMA,0,MODE_SMA,i);

  }